// Listing 1: synchronized-workers.c

#include <pthread.h>
#include <sys/types.h>
#include <stdio.h>
#include <sys/syscall.h>

pthread_t         t1, t2, t3;
pthread_barrier_t barrier;   // Deklaration einer Barrieren-Variable

void *worker (void *args) {
  int i, ret = 0;
  int tid = syscall (__NR_gettid);  // Get thread ID
  for (i=0; i<10; i++) {
    printf ("[%d]: i=%d\n", tid, i);
    if ((i==3) || (i==6)) {
      printf ("Thread %d erreicht Barriere\n", tid);
      // hier Platz fr Barrieren-Code; setze ret
      printf ("Thread %d hinter Barriere (ret=%d)\n", tid, ret);
    }
  }
}

int main () {
  // hier Platz fr Barrieren-Initialisierung
  printf ("Start\n");
  pthread_create (&t1, NULL, worker, NULL);
  pthread_create (&t2, NULL, worker, NULL);
  pthread_create (&t3, NULL, worker, NULL);
  pthread_join (t1, NULL);
  pthread_join (t2, NULL);
  pthread_join (t3, NULL);
  printf ("Fertig\n");
}
